#include "behaviour.h"

void parse_key_stack(GameControl** gamec) {

	gint direction,can;
	Monster* bump = NULL;
	
	if((*gamec)->turn->cost_cnt == 0) {
	
		if(g_list_length((*gamec)->key_stack) > 0) {

			switch((gint)g_list_first((*gamec)->key_stack)->data) {

				case GDK_KP_Up:
					direction = UP;
					break;
				case GDK_KP_Page_Up:
					direction = UP_RIGHT;
					break;
				case GDK_KP_Right:
					direction = RIGHT;
					break;
				case GDK_KP_Page_Down:
					direction = DOWN_RIGHT;
					break;
				case GDK_KP_Down:
					direction = DOWN;
					break;
				case GDK_KP_End:
					direction = DOWN_LEFT;
					break;
				case GDK_KP_Left:
					direction = LEFT;
					break;
				case GDK_KP_Home:
					direction = UP_LEFT;
					break;
				default:
					break;		
	
			}

			if((can = can_move_thing((gamec),(*gamec)->turn,direction,bump)) == YES_CLEAR) {

				move_thing((gamec),(*gamec)->turn,direction);
				(*gamec)->turn->cost_cnt = (*gamec)->turn->move_cost;
				change_monster_state_step((*gamec)->turn);
			}

			change_monster_state_facing((*gamec)->turn,direction);
			(*gamec)->key_stack = g_list_remove((*gamec)->key_stack,g_list_first((*gamec)->key_stack)->data);

		}

	} else {

		((*gamec)->turn->cost_cnt)--;

	}
}

void behave_do_nothing(GameControl** gamec,Monster* monster) {

}

void behave_guard_up_down(GameControl** gamec,Monster* monster) {

	Monster* bump = NULL;
	gint can,n;

	if(!(((gint)lookup_memory(monster->memory,0) == UP) || 
	     ((gint)lookup_memory(monster->memory,0) == DOWN) )) {

		monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);

	}

	if(monster->cost_cnt == 0) {

		if((gint)lookup_memory(monster->memory,1) == 10) {

			monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);

			if((gint)lookup_memory(monster->memory,0) == DOWN) {
				
				monster->memory = set_memory(monster->memory,0,INT_MEM,UP,NULL);
				change_monster_state_facing(monster,UP);

			} else {
		
				monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);
				change_monster_state_facing(monster,DOWN);

			}

		}

		if((gint)lookup_memory(monster->memory,0) == UP) {

			if((can = can_move_thing((gamec),monster,UP,bump)) == YES_CLEAR) {

				move_thing((gamec),monster,UP);
				monster->cost_cnt = monster->move_cost;
			} else {


				monster->memory = set_memory(monster->memory,0,INT_MEM,DOWN,NULL);
				monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);
				change_monster_state_facing(monster,DOWN);

			}

		} else {

			if((can = can_move_thing((gamec),monster,DOWN,bump)) == YES_CLEAR) {

				move_thing((gamec),monster,DOWN);
				monster->cost_cnt = monster->move_cost;

			} else {

				monster->memory = set_memory(monster->memory,0,INT_MEM,UP,NULL);
				monster->memory = set_memory(monster->memory,1,INT_MEM,0,NULL);
				change_monster_state_facing(monster,UP);
	
			}

		}

		change_monster_state_step(monster);
		n = (gint)lookup_memory(monster->memory,1) + 1;
		monster->memory = set_memory(monster->memory,1,INT_MEM,n,NULL);

	} else {
	
		(monster->cost_cnt)--;

	}

}

gint can_move_x_y(GameControl** gamec,gint x,gint y,gint access,Monster* bump) {

	bump = NULL;
	if(x<0 || y<0) return NO_ACCESS;
	if(MAP(x,y)->ios != NULL) bump = (Monster*)MAP(x,y)->ios;
	if(MAP(x,y)->mos != NULL) bump = MAP(x,y)->mos;
	if((access & MAP(x,y)->kind) == 0) return NO_ACCESS;
	if((MAP(x,y)->mos) != NULL) return NO_MONSTER;
	if((MAP(x,y)->ios) != NULL)
		if((MAP(x,y)->ios->properties & IS_TREADABLE) == 0) return NO_ITEM;
	return YES_CLEAR;

}

gint can_move_thing(GameControl** gamec,Monster* monster,gint direction,Monster* bump) {

	gint i,res;

	switch(direction) {

		case UP: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)-1,
				                       monster->access,bump)) != YES_CLEAR)
					return res;
			break;
		case UP_RIGHT: 
			for(i=1;i<=monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)-1,
                                                       monster->access,bump)) != YES_CLEAR)
					return res;
			if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y),
			                       monster->access,bump)) != YES_CLEAR)
				return res;
			break;
		case RIGHT: 
			for(i=0;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+i,
				                       monster->access,bump)) != YES_CLEAR)
					return res;
			break;
		case DOWN_RIGHT: 
			for(i=1;i<=monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)+(monster->height),
				                       monster->access,bump)) != YES_CLEAR)
					return res;
			if((res = can_move_x_y((gamec),(monster->x)+(monster->width),(monster->y)+(monster->height)-1,
			                       monster->access,bump)) != YES_CLEAR)
				return res;
			break;
		case DOWN: 
			for(i=0;i<monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+i,(monster->y)+(monster->height),
				                       monster->access,bump)) != YES_CLEAR)
					return res;
			break;
		case DOWN_LEFT: 
			for(i=1;i<=monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+((monster->width)-1)-i,(monster->y)+(monster->height),
                                                       monster->access,bump)) != YES_CLEAR)
					return res;
			if((res = can_move_x_y((gamec),monster->x-1,monster->y+monster->height-1,
                                               monster->access,bump)) != YES_CLEAR)
				return res;
			break;
		case LEFT: 
			for(i=0;i<monster->height;i++)
				if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y)+i,
                                                       monster->access,bump)) != YES_CLEAR)
					return res;
			break;
		case UP_LEFT: 
			for(i=1;i<=monster->width;i++)
				if((res = can_move_x_y((gamec),(monster->x)+((monster->width)-1)-i,(monster->y)-1,
				                       monster->access,bump)) != YES_CLEAR)
					return res;
			if((res = can_move_x_y((gamec),(monster->x)-1,(monster->y),
			                       monster->access,bump)) != YES_CLEAR)
				return res;
			break;
		default: 
			break;

	}

	return res;

}

void move_thing(GameControl** gamec,Monster* monster,gint direction) {

	gint oldx,oldy,x,y,i,j;

	oldx = monster->x;
	oldy = monster->y;
	
	remove_from_map((gamec),monster);

	switch(direction) {
	
		case UP: 
			x = monster->x;
			y = monster->y-1;
			break;
		case UP_RIGHT:
			x = monster->x+1;
			y = monster->y-1;
			break;
		case RIGHT:
			x = monster->x+1;
			y = monster->y;
			break;
		case DOWN_RIGHT:
			x = monster->x+1;
			y = monster->y+1;
			break;
		case DOWN:
			x = monster->x;
			y = monster->y+1;
			break;
		case DOWN_LEFT:
			x = monster->x-1;
			y = monster->y+1;
			break;
		case LEFT:
			x = monster->x-1;
			y = monster->y;
			break;
		case UP_LEFT:
			x = monster->x-1;
			y = monster->y-1;
			break;
		default:
			x = monster->x;
			y = monster->y;
			break;
	}

	add_to_map((gamec),monster,x,y);

	add_update((gamec),(monster->x),(monster->y));

	for(j=0;j<monster->height;j++)
	for(i=0;i<monster->width;i++) {

		add_update((gamec),(oldx)+i,(oldy)+j);

	}

}
