#include "monster.h"

Monster* new_monster() {
	
	Monster* new = (Monster*)g_malloc(sizeof(Monster));

	new->key = -1;
	new->type = MONSTER;
	new->x = 0;
	new->y = 0;

	new->name = g_string_new("new monster");
	new->width = 1;
	new->height = 1;
	new->sprites = NULL;
	new->animates = TRUE;
	new->state = 0;
	new->access = 0;
	new->properties = 0;
	new->sort = UNKNOWN_SORT;
	new->sub_sort = UNKNOWN_SUB_SORT;
	new->weight = 0;
	new->max_hp = 1;
	new->cur_hp = 1;
	new->dmg_sort = WIELD;
	new->min_dmg = 1;
	new->max_dmg = 1;
	new->use_cost = 1;
	new->armor = 0;
	new->max_weight = 0;
	new->contains = NULL;
	new->inside = NULL;
	new->stacked = NULL;

	new->state_flags = 0;
	new->memory = NULL;
	new->weapon_skills = NULL;
	new->non_weapon_skills = NULL;
	new->m_properties = 0;
	new->agression = 0;
	new->move_cost = 1;
	new->cost_cnt = 0;
	new->behaviour = NULL;

	return new;

}

void zap_monster(Monster* monster) {

	if(monster != NULL) {

		if(monster->name != NULL) {
			
			g_string_free(monster->name,TRUE);
			monster->name = NULL;
		
		}

		if(monster->sprites != NULL) {
			
			g_list_foreach(monster->sprites,(GFunc)g_free,NULL);
			g_list_free(monster->sprites);
			monster->sprites = NULL;

		}

		if(monster->contains != NULL) {

			g_list_free(monster->contains);
			monster->contains = NULL;

		}

		if(monster->memory != NULL) {

			g_list_foreach(monster->memory,(GFunc)g_free,NULL);
			g_list_free(monster->memory);
			monster->memory = NULL;

		}

		if(monster->weapon_skills != NULL) {

			g_list_foreach(monster->weapon_skills,(GFunc)g_free,NULL);
			g_list_free(monster->weapon_skills);
			monster->sprites = NULL;

		}
		if(monster->non_weapon_skills != NULL) {

			g_list_foreach(monster->non_weapon_skills,(GFunc)g_free,NULL);
			g_list_free(monster->non_weapon_skills);
			monster->non_weapon_skills = NULL;

		}

		g_free(monster);
		monster = NULL;

	}

}

void set_monster(GameControl** gamec,Monster* monster,guint16 sub_sort,gchar* name) {

	monster->sub_sort = sub_sort;
	monster->name = g_string_assign(monster->name,name);

	switch(monster->sub_sort) {

		case UNKNOWN_SUB_SORT: 
			break;
		case KNIGHT_HUMAN: 	
			monster->width = 1;
			monster->height = 1;
			monster->sprites = add_sprite(monster->sprites,DOWN_WALK_LEFT_1,KNIGHT_DOWN_WALK_LEFT_1);
			monster->sprites = add_sprite(monster->sprites,DOWN_WALK_RIGHT_1,KNIGHT_DOWN_WALK_RIGHT_1);
			monster->sprites = add_sprite(monster->sprites,UP_WALK_LEFT_1,KNIGHT_UP_WALK_LEFT_1);
			monster->sprites = add_sprite(monster->sprites,UP_WALK_RIGHT_1,KNIGHT_UP_WALK_RIGHT_1);
			monster->sprites = add_sprite(monster->sprites,LEFT_WALK_LEFT_1,KNIGHT_LEFT_WALK_LEFT_1);
			monster->sprites = add_sprite(monster->sprites,LEFT_WALK_RIGHT_1,KNIGHT_LEFT_WALK_RIGHT_1);
			monster->sprites = add_sprite(monster->sprites,RIGHT_WALK_LEFT_1,KNIGHT_RIGHT_WALK_LEFT_1);
			monster->sprites = add_sprite(monster->sprites,RIGHT_WALK_RIGHT_1,KNIGHT_RIGHT_WALK_RIGHT_1);
			monster->state = DOWN_WALK_LEFT_1;
			monster->state_flags = (LEFTY_BIT | WALK_BIT);
			monster->access = (GRASS | DIRT | STREET | SAND);
			monster->properties = 0;
			monster->sort = HUMAN;
			monster->weight = 750;
			monster->max_hp = 10; /* FIXME: should be endurance dependent */
			monster->cur_hp = 10; /* FIXME: should be endurance dependent */
			monster->min_dmg = 1; /* FIXME: should be strength dependent */
			monster->max_dmg = 3; /* FIXME: should be strength dependent */
			monster->use_cost = 2;
			monster->armor = 30;
			monster->max_weight = 400; /* FIXME: should be strength dependent */
			/* FIXME: add inventory items to monster->contains */
			/* FIXME: define weapon skills */
			/* FIXME: define non weapon skills */
			monster->m_properties = 0;
			monster->agression = 30;
			monster->move_cost = 3;
			monster->behaviour = behave_do_nothing;
			break;
		case BRUTE_OGRE: 			
			monster->width = 2;
			monster->height = 2;
			monster->sprites = add_sprite(monster->sprites,DOWN_WALK_LEFT_1,OGRE_DOWN_WALK_LEFT_1);
			monster->sprites = add_sprite(monster->sprites,DOWN_WALK_RIGHT_1,OGRE_DOWN_WALK_RIGHT_1);
			monster->sprites = add_sprite(monster->sprites,UP_WALK_LEFT_1,OGRE_UP_WALK_LEFT_1);
			monster->sprites = add_sprite(monster->sprites,UP_WALK_RIGHT_1,OGRE_UP_WALK_RIGHT_1);
			monster->state = DOWN_WALK_LEFT_1;
			monster->state_flags = (LEFTY_BIT | WALK_BIT);
			monster->access = (GRASS | DIRT | STREET | SAND);
			monster->properties = 0;
			monster->sort = OGRE;
			monster->weight = 4000;
			monster->max_hp = 30; /* FIXME: should be endurance dependent */
			monster->cur_hp = 30; /* FIXME: should be endurance dependent */
			monster->min_dmg = 1; /* FIXME: should be strength dependent */
			monster->max_dmg = 8; /* FIXME: should be strength dependent */
			monster->use_cost = 5;
			monster->armor = 50;
			monster->max_weight = 10; /* FIXME: should be strength dependent */
			/* FIXME: add inventory items to monster->contains */
			/* FIXME: define weapon skills */
			/* FIXME: define non weapon skills */
			monster->m_properties = (IS_HOSTILE);
			monster->agression = 1500;
			monster->move_cost = 5;
			monster->behaviour = behave_do_nothing;
			break;
		default:
			break;

	}

	if(g_list_find((*gamec)->monsters,monster) == NULL) {

		(*gamec)->monsters = g_list_append((*gamec)->monsters,monster);

	}

}


Memory* new_memory() {

	Memory* new = (Memory*)g_malloc(sizeof(Memory));

	new->key = 0;
	new->kind = UNKNOWN_MEM;
	new->int_mem = 0;
	new->pointer_mem = NULL;

	return new;

}

void zap_memory(Memory* mem) {

	if(mem != NULL) {

		g_free(mem);
		mem = NULL;

	}

}

GList* set_memory(GList* memory,gint32 key,gint16 kind,gint16 int_mem,gpointer pointer_mem) {

	Memory* new;
	GList* walker = memory;

	while(walker != NULL) {

		if(((Memory*)walker->data) != NULL)
		if(((Memory*)walker->data)->key == key) {

			((Memory*)walker->data)->kind = kind;
			((Memory*)walker->data)->int_mem = int_mem;
			((Memory*)walker->data)->pointer_mem = pointer_mem;
			return memory;

		} else {

			walker = walker->next;

		}

	}

	new = new_memory();
	new->key = key;
	new->kind = kind;
	new->int_mem = int_mem;
	new->pointer_mem = pointer_mem;
	memory = g_list_append(memory,new);

	return memory;

}

gpointer lookup_memory(GList* memory,gint32 key) {

	GList* walker = memory;

	while(walker != NULL) {

		if(((Memory*)walker->data) != NULL)
		if(((Memory*)walker->data)->key == key) {
			
			if(((Memory*)walker->data)->kind == INT_MEM) {
				
				return (gpointer)(((Memory*)walker->data)->int_mem);

			} else {

				return (gpointer)(((Memory*)walker->data)->pointer_mem);

			}


		} else {

			walker = walker->next;

		}

	}

	return NULL;

}

Skill* new_skill() {

	Skill* new = (Skill*)g_malloc(sizeof(Skill));

	new->key = 0;
	new->skill = 0;

	return new;

}

void zap_skill(Skill* ski) {

	if(ski != NULL) {

		g_free(ski);
		ski = NULL;

	}

}

GList* set_skill(GList* skills,gint32 key,gint16 skill) {
	
	Skill* new;
	GList* walker = skills;

	while(walker != NULL) {

		if(((Skill*)walker->data) != NULL)
		if(((Skill*)walker->data)->key == key) {
			
			((Skill*)walker->data)->skill = skill;
			return skills;

		} else {

			walker = walker->next;

		}

	}

	new = new_skill();
	new->key = key;
	new->skill = skill;
	skills = g_list_append(skills,new);

	return skills;

}

gint16 lookup_skill(GList* skills,gint32 key) {

	GList* walker = skills;

	while(walker != NULL) {

		if(((Skill*)walker->data) != NULL)
		if(((Skill*)walker->data)->key == key) {
			
			return ((Skill*)walker->data)->skill;

		} else {

			walker = walker->next;

		}

	}

	return 0;

}


void change_monster_state_step(Monster* monster) {

	monster->state_flags = (CHK(monster->state_flags,LEFTY_BIT)) ?
	                       (CLR(monster->state_flags,LEFTY_BIT)) :
	                       (SET(monster->state_flags,LEFTY_BIT));

	if(monster != NULL) {
		switch(monster->state) {

			case DOWN_WALK_LEFT_1:
				monster->state = DOWN_WALK_RIGHT_1;
				break;
			case DOWN_WALK_RIGHT_1:
				monster->state = DOWN_WALK_LEFT_1;
				break;
			case LEFT_WALK_LEFT_1:
				monster->state = LEFT_WALK_RIGHT_1;
				break;
			case LEFT_WALK_RIGHT_1:
				monster->state = LEFT_WALK_LEFT_1;
				break;
			case UP_WALK_LEFT_1:
				monster->state = UP_WALK_RIGHT_1;
				break;
			case UP_WALK_RIGHT_1:
				monster->state = UP_WALK_LEFT_1;
				break;
			case RIGHT_WALK_LEFT_1:
				monster->state = RIGHT_WALK_RIGHT_1;
				break;
			case RIGHT_WALK_RIGHT_1:
				monster->state = RIGHT_WALK_LEFT_1;
				break;
			default: 
				break;

		}

	}

}

void change_monster_state_facing(Monster* monster,gint direction) {

	if(monster != NULL) {

		if(CHK(monster->state,LEFTY_BIT) == 1) {

			switch(direction) {

				case UP:
					monster->state = UP_WALK_LEFT_1;
					break;
				case RIGHT:
					monster->state = RIGHT_WALK_LEFT_1;
					break;
				case DOWN:
					monster->state = DOWN_WALK_LEFT_1;
					break;
				case LEFT:
					monster->state = LEFT_WALK_LEFT_1;
					break;
				default:
					break;
		
			}

		} else {

			switch(direction) {

				case UP:
					monster->state = UP_WALK_RIGHT_1;
					break;
				case RIGHT:
					monster->state = RIGHT_WALK_RIGHT_1;
					break;
				case DOWN:
					monster->state = DOWN_WALK_RIGHT_1;
					break;
				case LEFT:
					monster->state = LEFT_WALK_RIGHT_1;
					break;
				default:
					break;		
			}

		}

	}

}
