#ifndef QUEST_SPRITE
#define QUEST_SPRITE

#include <gdk_imlib.h>
#include <stdlib.h>
#include "map.h"
#include "types.h"
#include "global.h"

Sprite* new_sprite();
void zap_sprite(Sprite* sprite);
SpriteNr* new_sprite_nr();
void zap_sprite_nr(SpriteNr* sprite_nr);

GList* add_sprite(GList* sprite_list,gint32 key,gint16 sprite_nr);
gint16 lookup_sprite_nr(GList* sprite_list,gint32 key);

gboolean is_outside_area(GameControl** gamec,Coords* tmp);
gboolean is_chopped_monster(GameControl** gamec,Coords* tmp);
gboolean is_chopped_itom(GameControl** gamec,Coords* tmp);

void make_area(GameControl** gamec);
void animate_space(GameControl** gamec,gint x,gint y);
void update_area_spaces(GameControl** gamec);
void repaint_drawing_area(GameControl** gamec);

void init_image_files(GameControl** gamec);
void init_sprites(GameControl** gamec);
void load(gpointer data,GameControl** gamec);

#endif /* QUEST_SPRITE */